package uk.co.christophercormack.netkernel.chartnk.accessors;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.category.CategoryDataset;
import org.netkernel.layer0.nkf.INKFRequestContext;


public class BarChartAccessor extends JFreeChartAccessor
{
    @Override
    public void onSource(INKFRequestContext aContext) throws Exception
    {
        
        CategoryDataset data = aContext.source("arg:data", CategoryDataset.class);
        
        JFreeChart chart = null;
        
        boolean legend= false;
        if (aContext.exists("arg:legend"))
        {
            legend= aContext.source("arg:legend", Boolean.class);
        }
        
        chart = ChartFactory.createBarChart(aContext.source("arg:title", String.class),
                                            aContext.source("arg:xAxisTitle", String.class),
                                            aContext.source("arg:yAxisTitle", String.class),
                                            data,
                                            PlotOrientation.VERTICAL,
                                            legend,
                                            false,
                                            false);
        
        chartOutput(aContext, chart);
    }
}
