package uk.co.christophercormack.netkernel.chartnk.accessors;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.DateAxis;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;
import org.jfree.data.time.TimeSeriesCollection;
import org.jfree.data.xy.XYDataset;
import org.netkernel.layer0.nkf.INKFRequestContext;


public class LineChartAccessor extends JFreeChartAccessor
{
    @Override
    public void onSource(INKFRequestContext aContext) throws Exception
    {
        
        XYDataset data = aContext.source("arg:data", XYDataset.class);
        
        JFreeChart chart = null;
        
        boolean legend= false;
        if (aContext.exists("arg:legend"))
        {
            legend= aContext.source("arg:legend", Boolean.class);
        }
        
        if (data instanceof TimeSeriesCollection)
        {
            DateAxis xAxis= new DateAxis(aContext.source("arg:xAxisTitle", String.class));
            NumberAxis yAxis= new NumberAxis(aContext.source("arg:yAxisTitle", String.class));
            XYPlot plot=new XYPlot((TimeSeriesCollection)data, xAxis, yAxis,new XYLineAndShapeRenderer());
            
            chart = new JFreeChart(plot);
            chart.setTitle(aContext.source("arg:title", String.class));
            if (!legend)
            {
                chart.removeLegend();
            }
        }
        else
        {
            chart = ChartFactory.createXYLineChart(aContext.source("arg:title", String.class),
                                                   aContext.source("arg:xAxisTitle", String.class),
                                                   aContext.source("arg:yAxisTitle", String.class),
                                                   (XYDataset)data,
                                                   PlotOrientation.VERTICAL,
                                                   legend,
                                                   false,
                                                   false);
        }
        
        chartOutput(aContext, chart);
    }
}
